var db;

var jQT=$.jQTouch({
	icon: 'kilo.png'
});

$(document).ready(function(){
	$('#settings form').submit(saveSettings);
	$('#createEntry form').submit(createEntry);
	//loadSettings();
	$('#settings').bind('pageAnimationStart', loadSettings);

	$('#dates li a').bind('click touchend',function(){
		var dayOffset = this.id;//0,1,2,3,4,5
		var date = new Date();
		date.setDate(date.getDate()-dayOffset);
		sessionStorage.currentDate = date.getMonth() + 1 + '/' + date.getDate() + '/' + date.getFullYear();
		refreshEntries();
	});

	var shortName='Kilo';
	var version='1.0';
	var displayName = 'Kilo';
	var maxSize = 65536;

	db = openDatabase(shortName, version, displayName, maxSize);

	db.transaction(
		function(transaction){
			transaction.executeSql(
				'create table if not exists entries ' +
				'(id integer not null primary key autoincrement, ' +
				' date date not null, food text not null, ' +
				' calories integer not null);'
			);
		}
	);


});

function saveSettings(){
	localStorage.age =$('#age').val();
	localStorage.weight=$('#weight').val();
	localStorage.budget=$('#budget').val();

	jQT.goBack();
	return false;
};

function loadSettings(){
	if (!localStorage.age)	{
		localStorage.age=" ";
	}
	if (!localStorage.weight)	{
		localStorage.wieght=" ";
	}
	if (!localStorage.budget)	{
		localStorage.budget=" ";
	}
	$('#age').val(localStorage.age);
	$('#weight').val(localStorage.weight);
	$('#budget').val(localStorage.budget);

};

function refreshEntries(){
	var currentDate = sessionStorage.currentDate;
	$('#date h1').text(currentDate);
	$('#date ul li:gt(0)').remove();
	db.transaction(
		function(transaction){
			transaction.executeSql(
				'select * from entries where date = ? order by food;',
				[currentDate],
				function(transaction, result){
					for(var i=0;i<result.rows.length;i++){
						var row = result.rows.item(i);
						var newEntryRow = $('#entryTemplate').clone();
						newEntryRow.removeAttr('id');
						newEntryRow.removeAttr('style');
						newEntryRow.data('entryId', row.id);
						newEntryRow.appendTo('#date ul');
						newEntryRow.find('.label').text(row.food);
						newEntryRow.find('.calories').text(row.calories);
						newEntryRow.find('.delete').click(function(){
							var clickedEntry = $(this).parent();
							var clickedEntryId = clickedEntry.data('entryId');
							deleteEntryById(clickedEntryId);
							clickedEntry.slideUp();
						})
					}
				},
				errorHandler
			);
		
		}	
	
	);

};

function createEntry(){
	var date=sessionStorage.currentDate;
	var calories = $('#calories').val();
	var food=$('#food').val();
	db.transaction(
		function(transaction){
			transaction.executeSql(
				'insert into entries (date, calories, food) values(?,?,?);',
				[date, calories, food],
				function(){
					refreshEntries();
					jQT.goBack();
				},
				errorHandler

			);	
		}
	);
	return false;
};

function errorHandler(transaction, error){
	alert('Oops. Error was' + error.message + '(Code ' + error.code +')');
	return true;
}

function deleteEntryById(id){
	db.transaction(
		function(transaction){
			transaction.executeSql(
				'delete from entries where id=?;',[id],null, errorHandler);
		}	
	);
}